; Programm zur Flchenermittlung
; Das Programm ist Freeware - 
; Der Autor (Ernst Dietrich) bernimmt daher keinerlei Haftungen.
; Die Benutzung erfolgt auf eigene Gefahr !
; 28.08.2003:  Es wurden kleinere Korrekturen vorgenommen

(defun c:ff (/ pkt apkt p1 dist anfragetxt)
  (command "_.UNDO" "_END")
  (command "_.UNDO" "_GROUP")
  (setvar "PLINETYPE" 2)
  (setq olderr *error*)
  (setq *error* ederr)
  (setq vorlay (getvar "CLAYER"))
  (if (not konf)
    (flkonfig)
  )
  (if (not komst)
    (rundg)
  )
  (setq pkt T)
  (eingab)
  (while pkt
    (if umf
      (progn
        (if (not (= pkt "Objekt"))
          (flsolid)
        )
        (setq anfragetxt (strcat "\nFlche = " (rtos flaech) " / " (rtos flaech 2 komst) 
                                        " m - Beschriften: Nein=Enter/<<Textmitte>> "))
        (if (= 'LIST (type (setq einfpkt (getpoint anfragetxt))))
          (beschr)
        )
        (if (= pkt "Objekt")
          (progn
            (redraw umf 4)
            (command "_.ERASE" sol "")
          )
          (command "_.ERASE" umf sol "")
        )
      )
    )
    (eingab)
  )
  (command "CLAYER" vorlay)
  (command "_.UNDO" "_END")
  (princ)
)
;-------------------------------------------------------------------------
(defun eingab ()  ;Eingabe einer Option oder Punkt in der Flche
  (osm0)
  (initget 128 "Objekt Umfahrung Konfig Rundg")
  (setq pkt (getpoint "\nObjekt/Umfahrung/Konfig/Rundung/<<Punkt fr automatisch:>> "))
  (osmz)
  (cond
    ((= pkt "Objekt") (objekt-berech))
    ((= pkt "Umfahrung") (umf-berech))
    ((= pkt "Konfig")
      (flkonfig)
      (eingab)
    )
    ((= pkt "Rundg")
      (rundg)
      (eingab)
    )
    (pkt (pkt-berech))
  )
)
;-------------------------------------------------------------------------
(defun rundg ()   
  (if (not (setq komst (getint "\nFlchentext runden auf wieviele Kommastellen: <0> ")))
    (setq komst 0)
  )
)
;-------------------------------------------------------------------------
(defun objekt-berech (/ obj)
  (setq obj (entsel "\nPolylinie oder Kreis whlen: "))
  (setq umf (car obj))
  (redraw umf 3)
  (command "_.AREA" "O" obj)
)
;-------------------------------------------------------------------------
(defun umf-berech (/ anfragetxt) ;Umfahrung 
  (setq pkt (setq p1 (getpoint "\nErster Punkt: ")))
  (command "_PLINE" p1)
  (while (setq pkt (getpoint pkt "\nNchster Punkt: <Schliessen> "))
    (osm0)
    (command pkt)
    (if pkt
      (progn
        (setq dist (distance p1 pkt))
        (princ (strcat "\nEntfernung= "(rtos dist 2 2) " m"))
        (setq p1 pkt)
      )
    )
    (osmz)
  )
  (command "S")
  (setq umf (entlast))
  (flsolid)
  (command "_.AREA" "O" umf)
  (setq flaech (getvar "AREA"))
  (setq anfragetxt (strcat "\nFlche = " (rtos flaech) " / " (rtos flaech 2 komst) " m - Beschriften: Nein=Enter/<<Textmitte>> "))
  (if (= 'LIST (type (setq einfpkt (getpoint anfragetxt))))
    (beschr)
  )
  (command "_.ERASE" umf sol "")
  (eingab)
)
;----------------------------------------------------------------------
(defun pkt-berech (/ lastnach lastvor)
  (load "c:/temp/VORAUSW")
  (vorauswahl)
  (command "_LAYER" "_T" "0" "")
  (command "CLAYER" 0)
  (setq lastvor (entlast))
  (command "_boundary" "O" "U" "N" aws "" "X" pkt "")
  (setq lastnach (entlast))
  (if (equal lastvor lastnach)
    (progn
      (setq umf nil)
      (setq flaech "")
      (alert "Keine gltige Umgrenzung gefunden")
    )
    (progn
      (setq umf (entlast))
      (redraw umf 3)
      (command "_.AREA" "O" umf)
      (setq flaech (getvar "AREA"))
    )
  )
)
;----------------------------------------------------------------------
(defun flsolid (/ counter lay)        ;zeigt die gefundene Flche durch ein temporres Solid an
  (if (not aws)                        ; wenn Auswahlsatz "aws" nicht existiert
    (progn                                
      (setq aws (ssadd))            ; erstelle den Auswahlsatz "aws" neu und
      (ssadd (entlast) aws)        ; fge das zuletzt erstellte Objekt hinzu.
    )
  )
  (command "REGENAUTO" 0)
  (setq lay "flsolid")
  (if (tblsearch "layer" lay)
    (command "_layer" "_s" lay "")
    (command "_layer" "m" lay "fa" "251" ""  "")
  )
  (command "_HATCH" "solid" umf "")
  (setq sol (entlast))
  (command "_draworder" "L" "" "N" (ssname aws 0))        ;das letzte Objekt wird unter die erste Grenze gelegt.
  (entupd sol)
  (setq counter 0)
  (repeat (sslength aws)
    (entupd (ssname aws counter))
    (setq counter (1+ counter))
  )
  (command "REGENAUTO" 1)
  (command "CLAYER" vorlay)
)
;----------------------------------------------------------------------
(defun beschr (/ txt)
;  (command "_.ERASE" umf sol "")
  (if (not (tblsearch "layer" "flaeche"))
    (command "_LAYER" "_M" "flaeche" "_C" "8" "" "")
    (command "CLAYER" "flaeche")
  )
  (setq txt (strcat (rtos flaech 2 komst) " m2"))
  (command "_.TEXT" "_J" "MZ" einfpkt 2 (+ (vt) 100) txt)  ;den Wert 100 entsprechend korrigieren
)
;----------------------------------------------------------------------
(defun ederr (s)
  (print s)
  (command "_.ERASE" umf sol "")
  (setq *error* olderr)
)
;----------------------------------------------------------------------
;diese Funktion fragt um Objekte, deren Layer wiederum als Filter fr die Flchenberechnung
;verwendet werden. Mit den Layernamen wird das LSP-File VORAUSW erzeugt, welches dann
;die Objekte zur Flchenberechnung auswhlt.

(defun flkonfig ()
  (initget 128 "Wie")
  (setq obj (nentsel "\nWelche Layer - Objekte anklicken/Wie bisher: <Voreinstellung> "))
  (cond
    ((= obj "Wie") (princ "\nBisherige Layer werden verwendet"))
    ((not obj) (stdard))        ;Layer laut Voreinstellung
    (obj (neuausw))
  )
  (setq konf T)
)
;----------------------------------------------------------------------
(defun neuausw (/ laynam lspfile)   ;Layer anklicken
  (setq lspfile (open "c:\\temp\\vorausw.lsp" "w"))
  (princ "(defun vorauswahl ()\n" lspfile)
  (princ "  (setq aws (ssget \"X\"\n" lspfile)
  (princ "    '((-4 . \"<or\")" lspfile)
  (while obj
    (princ "\n      " lspfile)
    (prin1 (cons 8 (setq laynam (cdr (assoc 8 (entget (car obj)))))) lspfile)
    (print laynam)
    (setq obj (nentsel "\nWelche Layer bercksichtigen - Objekte anklicken: "))  )
  (princ "\n    (-4 . \"or>\"))" lspfile)
  (princ "\n  ))" lspfile)
  (princ "\n)" lspfile)
  (close lspfile)
)
;----------------------------------------------------------------------
(defun stdard (/ lspfile)  ;Default-Layer
  (setq lspfile (open "c:\\temp\\vorausw.lsp" "w"))
  (princ "(defun vorauswahl ()\n" lspfile)
  (princ "  (setq aws (ssget \"X\"\n" lspfile)
  (princ "    '((-4 . \"<or\")" lspfile)
  
; hier knnen die Layer fr die Voreinstellung eingetragen werden - jetzt nur "0", Layer "abc" und "def" vorbereitet
  (princ "\n      " lspfile) (prin1 (cons 8 "0") lspfile)
;  (princ "\n      " lspfile) (prin1 (cons 8 "abc") lspfile)
;  (princ "\n      " lspfile) (prin1 (cons 8 "def") lspfile)

  (princ "\n    (-4 . \"or>\"))" lspfile)
  (princ "\n  ))" lspfile)
  (princ "\n)" lspfile)
  (close lspfile)
)
;----------------------------------------------------------------------
(defun osm0 ()
  (setq osm (getvar "osmode"))
  (setvar "OSMODE" 0)
)
;------------------------------------------------------------------------------
(defun osmz ()
  (setvar "OSMODE" osm)
)
;----------------------------------------------------------------------
(defun vt ()
  (cvunit (getvar "viewtwist") "radiant" "neugrad")
)

;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

(princ "\nStart mit   ff   ")